function YGS_BAG_PARSE()
	YGSBAG={}
	for b=0,4 do 
		for s=1,GetContainerNumSlots(b) do 
			if (GetContainerItemLink(b,s)) then
				--YssGuildShop_ConMsg(GetContainerItemLink(b,s)) -- debugline
				local texture, itemCount, locked, quality, readable = GetContainerItemInfo(b,s)
				local itemName = YssGuildShop_itemID_c(GetContainerItemLink(b,s))
				if YGSBAG[itemName] ~= nil then
					YGSBAG[itemName] = YGSBAG[itemName] + itemCount
				else
					YGSBAG[itemName] = itemCount
				end
			end
		end
	end
	for inv=1,19 do
		if (GetInventoryItemLink("player",inv)) then
			--YssGuildShop_ConMsg(GetContainerItemLink(b,s)) -- debugline
			local itemCount = GetInventoryItemCount("player",inv)
			local itemName = YssGuildShop_itemID_c(GetInventoryItemLink("player",inv))
			if YGSBAG[itemName] ~= nil then
				YGSBAG[itemName] = YGSBAG[itemName] + itemCount
			else
				YGSBAG[itemName] = itemCount
			end
		end
	end
	if YGSBANK ~= nil and YGSBAG ~= nil then
		--YssGuildShop:Print("Merge Scheduled") -- debugline
		YGS_BANK_BAG_MERGE()
	end
end

function YGS_BANK_PARSE()
	YGSBANK = {}
	local uniquecheck = 0
	local b = BANK_CONTAINER
        for s=1,GetContainerNumSlots(b) do 
		if (GetContainerItemLink(b,s)) then
			local texture, itemCount, locked, quality, readable = GetContainerItemInfo(b,s)
			local itemName = YssGuildShop_itemID_c(GetContainerItemLink(b,s))
			if YGSBANK[itemName] ~= nil then
				YGSBANK[itemName] = YGSBANK[itemName] + itemCount
			else
				YGSBANK[itemName] = itemCount
			end
		end
        end
        for b=5,11 do 
		for s=1,GetContainerNumSlots(b) do 
			if (GetContainerItemLink(b,s)) then
				--YssGuildShop_ConMsg(GetContainerItemLink(b,s)) -- debugline
				local texture, itemCount, locked, quality, readable = GetContainerItemInfo(b,s)
				local itemName = YssGuildShop_itemID_c(GetContainerItemLink(b,s))
				if YGSBANK[itemName] ~= nil then
					YGSBANK[itemName] = YGSBANK[itemName] + itemCount
				else
					YGSBANK[itemName] = itemCount
				end
			end
		end
        end
end

function YGS_BANK_BAG_MERGE()
	--YssGuildShop:Print("Merging.......") -- debugline
	local YGS_LOCAL_DB = {}
	local uniquecheck = 0
	if YGSBAG ~= nil then
		if YGSBANK ~= nil then
			for key, value in pairs(YGSBANK) do
				YGS_LOCAL_DB[key] = rawget(YGSBANK, key)
			end
			for key, value in pairs(YGSBAG) do
				if YGS_LOCAL_DB[key] ~= nil then
					YGS_LOCAL_DB[key] = "[" .. value .. "/" .. YGS_LOCAL_DB[key] .. "/" .. (YGS_LOCAL_DB[key] + value) .. "]"
				else
					YGS_LOCAL_DB[key] =  "[0/"..YGSBAG[key].."/"..YGSBAG[key].."]"
				end
			end
			for key, value in pairs(YGS_LOCAL_DB) do
				--YssGuildShop:Print(value[2])
				if string.gsub (value, "%[.*%]", "true") ~= "true" then
					--YssGuildShop:Print("Fixed: "..key)
					YGS_LOCAL_DB[key] = "[0/"..value.."/"..value.."]"
				end
			end
		end
	end
	table.sort(YGS_LOCAL_DB)
	
	uniquecheck = 0
	YGS_LOCAL_DB["YGS_ID"] = YssGuildShop:ID()
	if YGSDB ~= nil and YGSDB ~= {} then
		for k=1,table.maxn(YGSDB) do
			if YGSDB[k]["YGS_ID"][1] == YGS_LOCAL_DB["YGS_ID"][1] then
				YGSDB[k] = YGS_LOCAL_DB
				uniquecheck = 1
			end
		end
		if uniquecheck == 0 then
			YGSDB[table.maxn(YGSDB)+1] = YGS_LOCAL_DB
		end
	else
		YGSDB = {}
		YGSDB[1] = YGS_LOCAL_DB
	end

	YssGuildShop:Send()
end

function YssGuildShop_itemID_c(link)
	if not link then return end
	local _, _, itemID, ench, j1, j2, j3, j4, suffixID, uniqueID = string.find(link, "(%-?%d+):(%-?%d+):(%-?%d+):(%-?%d+):(%-?%d+):(%-?%d+):(%-?%d+):(%-?%d+)")
	return itemID
end

function YssGuildShop_itemID_d(item)
	if( not item ) then return nil end
	local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture = GetItemInfo(item) 
	return itemName, itemLink
end

function YssGuildShop_itemID_L(item)
	if( not item ) then return nil end
	local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture = GetItemInfo(item) 
	return itemLink
end
